/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dedicnost;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutput;
import java.io.ObjectOutputStream;
import java.io.Serializable;

/**
 *
 * @author balikm1
 */
public abstract class GrafickyObjekt implements Serializable {
    protected Kvadr boundingBox;
    
    protected abstract Kvadr vypoctiBoundingBox();
    
    //<editor-fold defaultstate="collapsed" desc="Public Methods">
    public Kvadr getBoundingBox() {
        if (boundingBox == null)
            boundingBox = vypoctiBoundingBox();
        return boundingBox;
    }
    
    public void uloz(String fileName) {
        try {
            // Serializace do souboru
            ObjectOutput out = new ObjectOutputStream(new FileOutputStream(fileName));
            out.writeObject(this);
            out.close();
        } catch (IOException e) {
            System.out.println("Chyba při zápisu souboru : "+e);
        }
    }
    
    public static GrafickyObjekt nacti(String fileName) {
        GrafickyObjekt k = null;
        try {
            File file = new File(fileName);
            ObjectInputStream in = new ObjectInputStream(new FileInputStream(file));
            // Deserializace objektu
            k = (GrafickyObjekt)in.readObject();
            in.close();
        } catch (ClassNotFoundException e) {
           System.out.println("Nemohu najít definici třídy: "+e);
        } catch (IOException e) {
           System.out.println("Chyba při čtení souboru : "+e);
        }
        return k;
    }
    //</editor-fold>
}
