/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dedicnost;

/**
 *
 * @author balikm1
 */
public class Kvadr extends GrafickyObjekt {
    
    protected double vyska;
    protected double sirka;
    protected double hloubka;

    //<editor-fold defaultstate="collapsed" desc="Initialization">
    public Kvadr(double vyska, double sirka, double hloubka) {
        this.vyska = vyska;
        this.sirka = sirka;
        this.hloubka = hloubka;
    }
    //</editor-fold>

    //<editor-fold defaultstate="collapsed" desc="Getters and Setters">
    public double getHloubka() {
        return hloubka;
    }

    public void setHloubka(double hloubka) {
        this.hloubka = hloubka;
        boundingBox = vypoctiBoundingBox();
    }

    public double getSirka() {
        return sirka;
    }

    public void setSirka(double sirka) {
        this.sirka = sirka;
        boundingBox = vypoctiBoundingBox();
    }

    public double getVyska() {
        return vyska;
    }

    public void setVyska(double vyska) {
        this.vyska = vyska;
        boundingBox = vypoctiBoundingBox();
    }
    //</editor-fold>

    //<editor-fold defaultstate="collapsed" desc="Object Overrides">
    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Kvadr other = (Kvadr) obj;
        if (Double.doubleToLongBits(this.vyska) != Double.doubleToLongBits(other.vyska)) {
            return false;
        }
        if (Double.doubleToLongBits(this.sirka) != Double.doubleToLongBits(other.sirka)) {
            return false;
        }
        if (Double.doubleToLongBits(this.hloubka) != Double.doubleToLongBits(other.hloubka)) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 5;
        hash = 29 * hash + (int) (Double.doubleToLongBits(this.vyska) ^ (Double.doubleToLongBits(this.vyska) >>> 32));
        hash = 29 * hash + (int) (Double.doubleToLongBits(this.sirka) ^ (Double.doubleToLongBits(this.sirka) >>> 32));
        hash = 29 * hash + (int) (Double.doubleToLongBits(this.hloubka) ^ (Double.doubleToLongBits(this.hloubka) >>> 32));
        return hash;
    }

    @Override
    public String toString() {
        return "Kvadr{" + "vyska=" + vyska + ", sirka=" + sirka + ", hloubka=" + hloubka + '}';
    }
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Helper Methods">
    @Override
    protected Kvadr vypoctiBoundingBox() {
        return new Kvadr(vyska, sirka, hloubka);
    }
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Public Methods">
    public double getObjem() {
        return vyska * sirka * hloubka;
    }
    
    public double getPovrch() {
        return 2 * (vyska*sirka + sirka*hloubka + vyska*hloubka);
    }
    //</editor-fold>
}
