/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package dedicnost;

/**
 *
 * @author balikm1
 */
public class Trojuhelnik extends GrafickyObjekt {
    protected double zakladna;
    protected double vyska;

    //<editor-fold defaultstate="collapsed" desc="Initialization">
    public Trojuhelnik(double zakladna, double vyska) {
        this.zakladna = zakladna;
        this.vyska = vyska;
    }
    //</editor-fold>

    //<editor-fold defaultstate="collapsed" desc="Getters and Setters">
    public double getVyska() {
        return vyska;
    }

    public void setVyska(double vyska) {
        this.vyska = vyska;
        boundingBox = vypoctiBoundingBox();
    }

    public double getZakladna() {
        return zakladna;
    }

    public void setZakladna(double zakladna) {
        this.zakladna = zakladna;
        boundingBox = vypoctiBoundingBox();
    }
    //</editor-fold>

    //<editor-fold defaultstate="collapsed" desc="Object Overrides">
    @Override
    public boolean equals(Object obj) {
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Trojuhelnik other = (Trojuhelnik) obj;
        if (Double.doubleToLongBits(this.zakladna) != Double.doubleToLongBits(other.zakladna)) {
            return false;
        }
        if (Double.doubleToLongBits(this.vyska) != Double.doubleToLongBits(other.vyska)) {
            return false;
        }
        return true;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = 29 * hash + (int) (Double.doubleToLongBits(this.zakladna) ^ (Double.doubleToLongBits(this.zakladna) >>> 32));
        hash = 29 * hash + (int) (Double.doubleToLongBits(this.vyska) ^ (Double.doubleToLongBits(this.vyska) >>> 32));
        return hash;
    }

    @Override
    public String toString() {
        return "Trojuhelnik{" + "zakladna=" + zakladna + ", vyska=" + vyska + '}';
    }
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Helper Methods">
    @Override
    protected Kvadr vypoctiBoundingBox() {
        return new Obdelnik(vyska, zakladna);
    }
    //</editor-fold>
    
    //<editor-fold defaultstate="collapsed" desc="Public Methods">
    public double getObsah() {
        return (zakladna * vyska) / 2;
    }
    //</editor-fold>
}
